import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long p = nextLong();
        int[] z1 = new int[n];
        int[] a1 = new int[n];
        int[] b1 = new int[n];
        for (int i = 0; i < n; i++) {
            int z = nextInt();
            int a = nextInt();
            int b = nextInt();
            z1[i] = z;
            a1[i] = a;
            b1[i] = b;
        }
        long l = 1;
        long r = p;
        while (l + 1 < r) {
            long m = (l + r) / 2;
            long ans = 0;
            for (int i = 0; i < n; i++) {
                if (m <= z1[i]) {
                    ans += (long) m * a1[i];
                } else {
                    ans += (long) a1[i] * z1[i] + (long) b1[i] * (m - z1[0]);
                }
            }
            if (ans < p) {
                l = m;
            } else {
                r = m;
            }
        }
        System.out.println(r);
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}