import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long p = nextLong();
        int[] z1 = new int[n];
        int[] a1 = new int[n];
        int[] b1 = new int[n];
        for (int i = 0; i < n; i++) {
            int z = nextInt();
            int a = nextInt();
            int b = nextInt();
            z1[i] = z;
            a1[i] = a;
            b1[i] = b;
        }
        for (int i = 1; i < 1e12; i++) {
            long ans = 0;
            for (int k = 0; k < n; k++) {
                if (i <= z1[k]) {
                    ans += (long) a1[k] * i;
                } else {
                    ans += (long) a1[k] * z1[k] + (long) b1[k] * (i - z1[k]);
                }
            }
            if (ans >= p) {
                System.out.println(i);
                return;
            }
        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}